#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Snow on your desktop
#AutoIt3Wrapper_Res_Fileversion=0.1.4.0
#AutoIt3Wrapper_Res_LegalCopyright=Dellairion
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Version 0.1.4
; By Dellairion
;
; Changelog:
; 0.1.4
;  - Added support for Windows versions before vista
;
; 0.1.3
;  - Snow stacks up now
;
; 0.1.2
;  - Added whirlfactor
;  - Snow will now stay at the bottom


; INCLUDES
#Include <Misc.au3>
#include <Array.au3>
#include <Constants.au3>
#include <GUIListBox.au3>
#include <GuiConstantsEx.au3>
#include <WindowsConstants.au3>
#include "includes\prospeed30.au3"
_Singleton(@ScriptName); Only 1 instance may be active at the same time

; OPTIONS
Opt("GUICloseOnESC", 0)
Opt("GUIOnEventMode", 1)
;Opt("OnExitFunc", "Quit")
;Opt("TrayMenuMode", 1)
;Opt("TrayOnEventMode", 1)


; VARIABLES F=pathtofile, P=path, S=system, LS=loadsprite, SP=sprite, IV=imagevar, A=array, L=rest
$S_OS = @OSVersion
$S_Username = @UserName
$F_Settings = "\settings.ini"
$S_Resolution_Width = @DesktopWidth ; add *2 if you have dual screen (cpu intensive)
$S_Resolution_Height = @DesktopHeight-28

$L_Snowflakes = 220 ; number of falling snow flakes at the same time (1-200)
$L_Whirlfactor = 15 ; X axis movement of snowflakes (0-30)
$L_Loopspeed = 80 ; can be compared with the cpu usage in % (1-100)
$L_Stackup = 25 ; snow stackup at the bottom (0-300)
;$L_Pixelsteps = 3 ; Amount of pixels between every refesh that the snowflake skip
$IV_Snowflakesize = 15 ; The size of 1 snowflake (to split them up out of the picture)
$IV_Snowflakecount = 12 ; The number of snowflakes in the image

If FileExists($F_Settings) Then
	$L_Snowflakes = IniRead($F_Settings, $S_Username, "Snowflakes", $L_Snowflakes)
	$L_Whirlfactor = IniRead($F_Settings, $S_Username, "Whirlfactor", $L_Whirlfactor)
	$L_Loopspeed = IniRead($F_Settings, $S_Username, "Loopspeed", $L_Loopspeed)
	$L_Stackup = IniRead($F_Settings, $S_Username, "Stackup", $L_Stackup)
	;$L_Pixelsteps = IniRead($F_Settings, $S_Username, "PixelSteps", $L_Pixelsteps)
EndIf

Global $Stackup_Timer = TimerInit()
Global $L_Stackup_Current = 0
Global $A_Snowflakeslist[1]
$A_Snowflakeslist[0] = 0


;LOADIN SNOWFLAKES
$LS_Snowflakes = loadsprite("images\snow.bmp")
If $S_OS <> "WIN_VISTA" Then
	WinMinimizeAll()
	Sleep(250)
EndIf
$L_HDC = GetDesktopHDC()
;$L_HDC = GetWindowHDC()
CreateBuffer($S_Resolution_Width, $S_Resolution_Height)
SetBuffer($L_HDC)
;InitPixelEffects()



;MAIN LOOP
$i = 1
While 1
	Sleep(1000-$L_Loopspeed*10)
	R_Snowflakes()
WEnd




;FUNCTIONS C=create, D=delete, R=render, LA=add to list, LD=delete from list, S=set, RS=reset
Func R_Snowflakes()
	If $A_Snowflakeslist[0] < $L_Snowflakes Then C_Snowflake()

	$F_Waitstackup = 7 ; (3-10)
	$F_Stackuptime = StringReplace($S_Resolution_Width, "-", "")/$L_Snowflakes*$F_Waitstackup*1000

	$F_Respawned = 0
	$i = 1
	Do
		If GetSpriteY($A_Snowflakeslist[$i]) >= $S_Resolution_Height-Round($IV_Snowflakesize/2, 0)-$L_Stackup_Current Then ; HasSpriteArrived($A_Snowflakeslist[$i]) <- doesnt work for sprites in table mode
			If $L_Stackup > 0 Then
				If $L_Stackup_Current < $L_Stackup Then
					SpriteToHDC($A_Snowflakeslist[$i])
				ElseIf TimerDiff($Stackup_Timer) < $F_Stackuptime Then
					SpriteToHDC($A_Snowflakeslist[$i])
				EndIf
			EndIf

			;Sleep(Round($L_Snowflakes/3+20, 0))
			D_Snowflake($A_Snowflakeslist[$i])
			;If $F_Respawned < $L_Snowflakes/10+1 Then RS_Snowflake($A_Snowflakeslist[$i])

			If $A_Snowflakeslist[0] < $L_Snowflakes And $F_Respawned < $L_Snowflakes/10+1 Then C_Snowflake()
			$F_Respawned += 1
		Else
			$i += 1
		EndIf
	Until $i >= $A_Snowflakeslist[0]

	If TimerDiff($Stackup_Timer) >= $F_Stackuptime And $L_Stackup_Current < $L_Stackup Then
		$L_Stackup_Current += 2
		$Stackup_Timer = TimerInit()
	EndIf
EndFunc


Func C_Snowflake()
	$F_Snowflaketype = Random(0, $IV_Snowflakecount-1, 1)
	$F_Snowflakespeed = Random(1, 3, 1)
	$F_Snowflakestartx = Random(-$IV_Snowflakesize+1, $S_Resolution_Width-1, 1)
	$F_SpriteID = sprite($LS_Snowflakes, $L_HDC, $F_Snowflaketype*$IV_Snowflakesize, 0, $IV_Snowflakesize, $IV_Snowflakesize, 1, 1, 1, $F_Snowflakestartx, -$IV_Snowflakesize-1)

	setspritespeed($F_SpriteID, $F_SnowflakeSpeed, $F_SnowflakeSpeed)
	;movesprite($F_SpriteID, $F_Snowflakestartx, $S_Resolution_Height-Round($IV_Snowflakesize/2, 0))
	S_Whirlfactor($F_SpriteID)
	LA_Snowflake($F_SpriteID)

	$A_Snowflakeslist[0] += 1
EndFunc


Func D_Snowflake($F_SpriteID)
	MarkSprite($F_SpriteID, 1)
	DeleteSprite($F_SpriteID)
	LD_Snowflake($F_SpriteID)
	cleanup(1)

	$A_Snowflakeslist[0] -= 1
EndFunc

#cs
Func RS_Snowflake($F_SpriteID) ; weard
	$F_Snowflaketype = Random(0, $IV_Snowflakecount-1, 1)
	$F_Snowflakespeed = Random(1, 3, 1)
	$F_Snowflakestartx = Random(-$IV_Snowflakesize+1, $S_Resolution_Width-1, 1)

	SetSpritePos($F_SpriteID, $F_Snowflakestartx, -$IV_Snowflakesize-1, $F_Snowflakestartx, -$IV_Snowflakesize-1)
	SetSpriteAnim($F_SpriteID, $F_Snowflaketype*$IV_Snowflakesize, 0, $IV_Snowflakesize, $IV_Snowflakesize, 1, 1, 1)
	SetSpriteSpeed($F_SpriteID, $F_Snowflakespeed, $F_Snowflakespeed)
	S_Whirlfactor($F_SpriteID)
EndFunc
#ce

Func LA_Snowflake($F_SpriteID)
	_ArrayAdd($A_Snowflakeslist, $F_SpriteID)
EndFunc


Func LD_Snowflake($F_SpriteID)
	_ArrayDelete($A_Snowflakeslist, _ArraySearch($A_Snowflakeslist, $F_SpriteID))
EndFunc


Func S_Whirlfactor($F_SpriteID)
	$X = GetSpriteX($F_SpriteID)
	$Y = GetSpriteY($F_SpriteID)
	$Y_End = $S_Resolution_Height-Round($IV_Snowflakesize/2, 0)-$L_Stackup_Current

	If $L_Whirlfactor = 0 Then
		movesprite($F_SpriteID, $X, $Y_End)
	Else
		$X2 = $X
		$X_Movement_Prev = 0
		$F_Stepsize = 50
		$F_Table = $X&" "&$Y
		For $i = $Y+$F_Stepsize To $Y_End-$F_Stepsize Step $F_Stepsize
			$X_Movement = Random($X_Movement_Prev-5, $X_Movement_Prev+5, 1)
			If $X_Movement > $L_Whirlfactor Then $X_Movement = $L_Whirlfactor
			If $X_Movement < -$L_Whirlfactor Then $X_Movement = -$L_Whirlfactor

			$F_Table &= " "&$X2+$X_Movement&" "&$i

			$X2 = $X2+$X_Movement
			$X_Movement_Prev = $X_Movement
		Next
		$F_Table &= " "&$X2&" "&$Y_End

		SpriteTableMode($F_SpriteID, 1)
		SetSpriteMovingMode($F_SpriteID, 1)
		;movesprite($F_SpriteID, $X, $Y_End) ; lol
		MoveSpriteWithTable($F_SpriteID, $F_Table)
	EndIf
EndFunc


;Func HasSpriteWithTableArrived($F_SpriteID)
;
;EndFunc


Func Quit()
	DeleteAllSprites()
	DestroyBuffer()
	ControlSend("Program Manager", "", "", "{F5}")
	Exit
EndFunc
